|
|	alloca - storage allocator
|
|	char *alloca ( size )
|	int size;
|
|	Like malloc, but allocates the memory in the stack frame.
|	Allocated memory is released when the caller executes the
|	'unlk' opcode just before exit.
|
	.data
	.text
	.globl	_alloca
_alloca:
	movl	sp@+,a0		| get return address
	movl	a7,d0		| get frame pointer
	subl	sp@,d0		| subtract requested size
	andl	#~3,d0		| align (long)
	movl	d0,sp		| new sp
	tstb	sp@(-132)	| stack probe (request more stack)
	addql	#4,d0		| return pointer
	jmp	a0@		| jump, can't use ret
	.data
|
|	This implementation is adapted from Gnu emacs by G Larsson
|	for the abcenix and dnix c compilers.
|
